﻿var Providers = {
    "yahoo": "http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20rss%20where%20url%3D%22",
	"google": "http://www.google.com/reader/public/javascript/feed/"
	};
Providers.getNames = function(){
	var arr = [];
	for(prop in this) if (this.hasOwnProperty(prop)) {
		if (prop == 'getNames') continue;
	    arr.push(prop);
	}
	return arr;
};
var itemsProject = [{url:''}];
var timeOut = null;

function start(){
	initMain();
	initFlyout();
	initSettings();
	updateList();
}

function dockStateChanged() {
    if (System.Gadget.docked) {
		var width = '250px';
		var height = '250px';
        $(document.body).css('width', width).css('height', height);
    } else {
		var width = '250px';
		var height = parseInt($("#gadgetContent").css('height'));//'240px';
        $(document.body).css('width', width)
						.css('height', (height)+'px');
    }
}

function initMain(){
	System.Gadget.Settings.write("PrivateSetting_GadgetOpacity", 100);
    System.Gadget.onDock = dockStateChanged;
    System.Gadget.onUndock = dockStateChanged;
    dockStateChanged();
	$("#updateLink").get(0).onclick = function() {
	    updateList();
	}
}

function initSettings() {
    System.Gadget.settingsUI = 'settings.html';
    //System.Gadget.onSettingsClosed = onSettingsClosed;
	// устанавливаем значения по умолчанию при первом запуске гаджета
	var provider = System.Gadget.Settings.readString('provider');
	if(provider == '') {
		System.Gadget.Settings.writeString('provider', Providers.getNames()[0]);
	}
	var updateTime = System.Gadget.Settings.readString('updateTime');
	if(updateTime == '') {
		System.Gadget.Settings.writeString('updateTime', '5');
	}
	var soundOn = System.Gadget.Settings.readString('soundOn');
	if(soundOn == '') {
		System.Gadget.Settings.writeString('soundOn', '1');
	}
	var countViewProject = System.Gadget.Settings.readString('countViewProject');
	if(countViewProject == '') {
		System.Gadget.Settings.writeString('countViewProject', '10');
	}
}

function initFlyout() {
	System.Gadget.Flyout.file = 'flyout.html';
	//System.Gadget.Flyout.onShow = onFlyoutShow;
	//System.Gadget.Flyout.onHide = onFlyoutHide;
	// открываем и закрываем флайаут
	$("#flyoutLink").get(0).onclick = function() {
		System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
		return false;
	}
}

function getRSS(){
	$.ajaxSetup( { "async": false } );
	var object;
	var provider = System.Gadget.Settings.readString('provider');
	var login = System.Gadget.Settings.readString('login');
	var codeSetting = System.Gadget.Settings.readString('codeSetting');
	var countViewProject = System.Gadget.Settings.readString('countViewProject');
	var urlRSS = 'http://feeds.feedburner.com/AssassinsCreedBrotherhoodAC3?format=xml';
	
	if (login && codeSetting){
		urlRSS = urlRSS + '?login=' + login + '&code=' + codeSetting;
	}
	urlRSS = encodeURIComponent(urlRSS);
	var url = '';
	
	switch (provider){
					
		case 'yahoo':
			url = Providers[provider] + urlRSS + '%22%20limit%20' + countViewProject + '&format=json&callback=?';
			$.getJSON(url, function(json){ 
				var items = [];
				$.each(json.query.results.item, function(key, val) {
					object = { url: val.link,
							   title: val.title,
							   desc: val.description.replace(/\n/g," "),
							   date: new Date(val.pubDate)};
					items[key] = object;
				});
				displayProject(items);
			});

		break;
		case 'google':
			url = Providers[provider] + urlRSS + '?n=' + countViewProject + '&callback=?';
			$.getJSON(url, function(json){
				var items = [];
				$.each(json.items, function(key, val) {
					object = { url: val.alternate.href,
							   title: val.title,
							   desc: val.summary,
							   date: new Date(val.published*1000)};
					items[key] = object;
				});
				displayProject(items)
			});

			break;
		default:
			throw new Exeption("Not default provider.");
			break;
	}

}

function displayProject(items){
	
	if ((items[0].url != itemsProject[0].url) || (items.length != itemsProject.length)){
		if (System.Gadget.Settings.readString('soundOn') == '1') System.Sound.beep(); //Beep, Exclamation, Hand, Question
		var options = {};
		//$("#projectList").html('<li>Загружаю...</li>');
		var list = [];
		$.each(items, function(key, val) {
			var addclass = '';
			if ($.inArray(val.url,getArrayUrl(itemsProject)) == -1) addclass = 'new';
			list.push('<li id="prj_' + key + '" class="' + addclass + '"><a blank="" href="'+val.url+'">' + val.title + '</a> <span class="date">('Дата'+'val.date.getDate()+val.date.getMonth()+val.date.getFullYear()+' Время'+val.date.getHours() + ':' + val.date.getMinutes() +')</span></li>');
		});
		$("#projectList").html(list.join(''));
		$( ".new" ).effect( 'pulsate', options, 400, function(){this.style.removeAttribute('filter'); $(".new").removeAttr('style'); });
		itemsProject = items;
		dockStateChanged();
	}
	document.itemsProject = itemsProject;
}

function getArrayUrl(items){
	var arr = [];
	$.each(items, function(key, val) {
		arr[key] = val.url;
	});
	return arr;
}

function updateList(){
	clearTimeout(timeOut);
	System.Gadget.Flyout.show = false;
	$( "#projectList" ).fadeOut(200,function(){this.style.removeAttribute('filter');});
	getRSS();
	$( "#projectList" ).fadeIn(100,function(){this.style.removeAttribute('filter');});
	var updateTime = parseInt(System.Gadget.Settings.readString('updateTime'));
	timeOut = setTimeout(updateList, updateTime*60*1000);	
}