﻿function settingsClosing(event) {
    if (event.closeAction == event.Action.commit) {
		// убираем выделение ошибок
		$('.error').removeClass('error');
		
		var login = $('#login').val();
		var codeSetting = $('#codeSetting').val();
		
		var countViewProject =  parseInt($('#countViewProject').val());
		if(isNaN(countViewProject) || countViewProject > 25 || countViewProject < 2) {
			// отменяем закрытие окна настроек
			event.cancel = true;
			// показываем ошибку
			$('#countViewProject').parent().addClass('error');
		}
		
		var updateTime =  parseInt($('#updateTime').val());
		if(isNaN(updateTime) || updateTime > 600 || updateTime < 1) {
			// отменяем закрытие окна настроек
			event.cancel = true;
			// показываем ошибку
			$('#updateTime').parent().addClass('error');
		}
		
		var provider = $('#provider').val();
		var soundOn = $('#soundOn').get(0).checked ? '1' : '0';
			
		// если не было ошибок сохраняем значения
		if(!event.cancel) {	
			System.Gadget.Settings.writeString('provider', provider);
			System.Gadget.Settings.writeString('updateTime', updateTime);
			System.Gadget.Settings.writeString('countViewProject', countViewProject);
			System.Gadget.Settings.writeString('soundOn', soundOn);
		}
    } 
}

function main() {
    System.Gadget.onSettingsClosing = settingsClosing;
	// считываем старые значения настроек и показываем их в форме
	$('#provider').val(System.Gadget.Settings.readString('provider'));
	$('#updateTime').val(System.Gadget.Settings.readString('updateTime'));
	$('#countViewProject').val(System.Gadget.Settings.readString('countViewProject'));
	$('#soundOn').get(0).checked = (System.Gadget.Settings.readString('soundOn') == '1');
}

$(document).ready(main);